---
- name: Update and upgrade system packages
  block:
    - name: Check if upgrade has been run before
      ansible.builtin.stat:
        path: "/etc/ansible-upgrade-ran"
      register: upgrade_ran

    - name: Update apt cache
      ansible.builtin.apt:
        update_cache: yes
        cache_valid_time: 3600
      when: not upgrade_ran.stat.exists

    - name: Upgrade apt packages
      ansible.builtin.apt:
        upgrade: 'safe'
      when: not upgrade_ran.stat.exists

    - name: Create flag file
      ansible.builtin.file:
        path: "/etc/ansible-upgrade-ran"
        state: touch
      when: not upgrade_ran.stat.exists
  become: yes